(ns world2D.vec2D)

(defn length [[x y]]
  (Math/sqrt (+ (* x x) (* y y))))

(defn *v [& vecs-or-nums]
  (vec (apply map * (map #(if (number? %) [% %] %) vecs-or-nums))))

(defn +v [& vecs-or-nums]
  (vec (apply map + (map #(if (number? %) [% %] %) vecs-or-nums))))

(defn -v [& vecs-or-nums]
  (vec (apply map - (map #(if (number? %) [% %] %) vecs-or-nums))))

;(defn *v [& vecs-or-nums]
;  (apply map * (map #(if (number? %) [% %] %) vecs-or-nums)))
;
;(defn +v [& vecs-or-nums]
;  (apply map + (map #(if (number? %) [% %] %) vecs-or-nums)))
;
;(defn -v [& vecs-or-nums]
;  (apply map - (map #(if (number? %) [% %] %) vecs-or-nums)))

(defn avgv [& vecs-or-nums]
  (if (empty? vecs-or-nums)
    [0 0]
    (mapv #(/ % (count vecs-or-nums)) 
          (apply +v vecs-or-nums))))

(defn nrm [xy]
  (let [len (length xy)]
    (if (zero? len)
      xy
      (vec (map #(/ % len) xy)))))

(defn nrm-wrt [xy limit]
  (if (<= (length xy) limit)
    xy
    (*v limit (nrm xy))))

